"""
Vhex default build management
"""
import sys

from core.build.project import VxProject
from core.logger import log

__all__ = [
    'build_default_cli'
]

def build_default_cli(argv):
    """Parse CLI arguments"""
    board_target = None
    if argv[0].find('build-') == 0:
        board_target = argv[0][6:]

    path = None
    verbose = False
    extra_conf = {
        'configure' : '',
        'build' : '',
    }
    for arg in argv[1:]:
#        if arg in ['-r', '--rebuild']:
#            force_rebuild = True
#            continue
#        if arg in ['-u', '--update']:
#            update_dependencies = True
#            continue
        if arg in ['-v', '--verbose']:
            verbose = True
            continue
        if arg.find('--extra-conf=') == 0:
            extra_conf['configure'] += ' ' + arg[13:]
            continue
        if arg.find('--extra-build=') == 0:
            extra_conf['build'] += ' ' + arg[14:]
            continue
        if path:
            log.error(f"argument '{arg}' not recognized")
            sys.exit(85)
        path = arg

    return VxProject(path, extra_conf=extra_conf).build(
        board_target,
        verbose
    )
